/*

THE FIRST PART of this stylesheet "relativizes" sizes, i.e. replaces
sizes/lengths defined in terms of `px` in the stylesheets that are automatically
applied by Markdeep with lenghts defined in terms of `rem`. This enables scaling
the entire document just by adjusting the <html> root element's font size –
exactly what's required to enable fullscreen presentations.

The conversion rule is simple: `<N>px` => `calc(<N>rem/var(--rf))`, where `--rf`
is the base font size the original `px` measurements are assumed to be relative
to. `--rf` is the browser default, `16px`.

This first part, when applied to a standard Markdeep document, is designed *not
to effect any visual changes* (until you increase the root font size, that is).

Note: I would've liked to define `--rf: calc(1rem / 16px)` and then use it like
      `calc(<N>px * var(--rf))`, but `calc` understandably, yet disappointingly,
      can't deal with "rem per pixel" units.

Note: This is based on Markdeep 1.05 and will need adjustments for newer
      Markdeep versions.

********************************************************************************

THE SECOND PART sets some sensibe defaults for slides-related stuff that most
every theme would otherwise have to set individually.

*/

:root {
    --rf: 16;
}

/********************************/
/* Relativize "BODY_STYLESHEET" */
/********************************/

body {
    padding: calc(20rem / var(--rf));
}


/***************************/
/* Relativize "STYLESHEET" */
/***************************/

.md code,
.md pre {
    font-size: calc(13.43rem / var(--rf));  /* actually: codeFontSize */
}

.md div.title {
    font-size: calc(26rem / var(--rf));
}

.md div.afterTitles {
    height:calc(10rem / var(--rf));
}

.md pre.listing .linenumbers span.line:before{
    width:calc(30rem / var(--rf));
    margin-left:calc(-28rem / var(--rf));
    padding-right:calc(13rem / var(--rf));
    margin-right:calc(8rem / var(--rf));
}

.md div.tilde {
    margin:calc(20rem / var(--rf)) 0 calc(-10rem / var(--rf));
}

.md .imagecaption,
.md .tablecaption,
.md .listingcaption {
    margin: calc(7rem / var(--rf)) calc(5rem / var(--rf)) calc(12rem / var(--rf));
}

.md blockquote.fancyquote {
    margin: calc(25rem / var(--rf)) 0 calc(25rem / var(--rf));
}

.md blockquote.fancyquote::before {
    font-size: calc(45rem / var(--rf));
    margin-right: calc(6rem / var(--rf));
}

.md span.fancyquote::after {
    font-size: calc(45rem / var(--rf));
    margin-left: calc(6rem / var(--rf));
}

.md blockquote.fancyquote .author {
    margin-top: calc(10rem / var(--rf));
}

.md div.title,
contents,
.md .tocHeader,
h1,
h2,
h3,
h4,
h5,
h6,
.md .shortTOC,
.md .mediumTOC,
.nonumberh1,
.nonumberh2,
.nonumberh3,
.nonumberh4,
.nonumberh5,
.nonumberh6 {
    margin: calc(13.4rem / var(--rf)) 0 calc(13.4rem / var(--rf));
    padding: calc(15rem / var(--rf)) 0 calc(3rem / var(--rf));
}

/* diagrams are scaled differently */
/* .md svg.diagram {
    font-size: calc(13.43rem / var(--rf));  /* actually: codeFontSize
    stroke-width: calc(2rem / var(--rf));  /* actually: STROKE_WIDTH
} */

.md h1,
.md .tocHeader,
.md .nonumberh1 {
    border-bottom-width: calc(3rem / var(--rf));
    font-size: calc(20rem / var(--rf));
}

.md h2,
.md .nonumberh2{
    border-bottom-width: calc(2rem / var(--rf));
    font-size: calc(18rem / var(--rf));
}

.md h3,
.md h4,
.md h5,
.md h6,
.md .nonumberh3,
.md .nonumberh4,
.md .nonumberh5,
.md .nonumberh6 {
    font-size: calc(16rem / var(--rf));
}

.md div.table {
    margin: calc(16rem / var(--rf)) 0 calc(16rem / var(--rf)) 0;
}

.md table.calendar{
    font-size:calc(11rem / var(--rf));
}

.md table.calendar th {
    font-size: calc(16rem / var(--rf));
}

.md table.table th {
    border-width: calc(1rem / var(--rf));
    padding: calc(8rem / var(--rf)) calc(15rem / var(--rf)) calc(8rem / var(--rf)) calc(15rem / var(--rf));
}

.md table.table td {
    padding: calc(5rem / var(--rf)) calc(15rem / var(--rf)) calc(5rem / var(--rf)) calc(15rem / var(--rf));
    border-width: calc(1rem / var(--rf));
}

.md pre.tilde {
    border-top-width: calc(1rem / var(--rf));
    border-bottom-width: calc(1rem / var(--rf));
    padding: calc(5rem / var(--rf)) 0 calc(5rem / var(--rf)) calc(20rem / var(--rf));
}

.md dl > dd {
    margin-top: calc(-8rem / var(--rf));
    margin-bottom: calc(8rem / var(--rf))
}

.md dl > table {
    margin: calc(35rem / var(--rf)) 0 calc(30rem / var(--rf));
}

.md .endnote {
    font-size: calc(13rem / var(--rf));
    line-height: calc(15rem / var(--rf));
    padding-left: calc(10rem / var(--rf));
    text-indent: calc(-10rem / var(--rf))
}

.md .bib {
    padding-left: calc(80rem / var(--rf));
    text-indent: calc(-80rem / var(--rf));
}

.markdeepFooter {
    font-size: calc(9rem / var(--rf));
    padding-top: calc(80rem / var(--rf));
}

.md .mediumTOC {
    font-size: calc(12rem / var(--rf));
    line-height: calc(15rem / var(--rf));
    border-left-width: calc(1rem / var(--rf));
    padding-left: calc(15rem / var(--rf));
    margin: calc(15rem / var(--rf)) calc(0rem / var(--rf)) calc(15rem / var(--rf)) calc(25rem / var(--rf));
}

.md .longTOC .level1 {
    padding-top: calc(12rem / var(--rf));
    margin: 0 0 calc(-20rem / var(--rf));
}

.md .shortTOC {
    margin-top: calc(15rem / var(--rf));
    font-size: calc(14rem / var(--rf));
}

.md .admonition-title {
    border-bottom-width: calc(1rem / var(--rf));
    padding-bottom: calc(4rem / var(--rf));
    margin-bottom: calc(4rem / var(--rf));
}

.md .admonition.tip::before {
    top: calc(3rem / var(--rf));
}

.md .admonition.warn::before,
.md .admonition.warning::before {
    top: calc(2rem / var(--rf));
}

.md .admonition.error::before {
    top: calc(2rem / var(--rf));
}


/*********************************************************************/
/* Relativize "Add more spacing before the title in a long document" */
/*********************************************************************/

div.title {
    padding-top: calc(40rem / var(--rf));
}

div.afterTitles {
    height: calc(15rem / var(--rf));
}


/***************************************************************/
/* Relativize "Creates a style sheet containing elements like" */
/***************************************************************/

.md h1::before,
.md h2::before,
.md h3::before,
.md h4::before,
.md h5::before,
.md h6::before {
    margin-right: calc(10rem / var(--rf));
}


/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

* {
    box-sizing: border-box;
}

body {
    text-align: left;  /* not: justify */
    max-width: 100%;
}

.md h1, .md h2, .md h3 {
    color: inherit;
}

/* hide section numbering and the associated margins */
.md h1:before,
.md h2:before,
.md h3:before {
    content: '' !important;
    margin: 0 !important;
}

.md center,
.md blockquote.fancyquote {
    margin: 1rem 0;
}

/* enable margin collapse: imagine a paragraph and a headline (both margin: 1rem
0), with the headline's a.target between them. jumping to the target should
still work just fine */
.md a.target {
    position: absolute;
}


/* tables */
.md table {
    font-size: inherit;  /* not sure why it doesn't automatically inherit the body's font size */
}
.md table.calendar {
    font-size: 0.6rem;
    font-family: inherit;
}


/* make diagram lines a bit thinner (must be defined in px – diagrams are scaled differently than the rest) */
.md svg.diagram {
    stroke-width: 1.5px;
}


/* quotes */
.md blockquote.fancyquote {
    padding: 0;
}
.md blockquote.fancyquote .author {
    margin-top: 0.25rem;
}


/* code */
.md pre {
    margin-top: 1rem;
    margin-bottom: 0.5rem;
}
.md pre.listing {
    resize: none;  /* remove resizability indicator from listings */
}
.md pre.listing .linenumbers {
    padding-left: 0.3rem;
}
.md pre.listing .linenumbers span.line:before {
    width: 1rem;
    margin-left: -0.5rem;
    margin-right: 1rem;
    padding: 0;
}
@media print {
    .md .listing code {
        white-space: pre;
    }
}
.hljs-comment {
    font-style: italic;
}


/* lists (with pluses, minuses or dots as item signifiers) */
.md ol {
    padding-left: 1.3rem;  /* this is otherwise defined in terms of px by the browser.*/
}
.md ul {
    list-style: none;
    padding: 0;
}
.md ul > li.plus:before {
    content: "+";
    padding-right: 0.7em;
}
.md ul > li.minus:before {
    content: "–";
    padding-right: 0.7em;
}
.md ul > li.asterisk:before {
    content: "●";
    font-size: 0.9em;
    padding-right: 0.7em;
}
.md ul > li {
    padding-left: 1.2em;
    text-indent: -1.2em;
}


/* media */
.md .imagecaption,
.md .tablecaption,
.md .listingcaption {
    margin: -0.5rem 0 0;  /* accounts for the 1rem margin on <center>, which captions are wrapped in */
}
.md img {
    max-width: 100%;
    max-height: calc(var(--slide-height) - 2rem);
}
.md video {
    width: 21.33rem;
}
.md iframe[src^="https://www.youtube"],
.md iframe[src^="https://player.vimeo"] {
    width: 21.33rem;
    height: 12rem;  /* 16:9 aspect ratio */
}


/*

TODO images and videos that fill the slide completely, perhaps with black background if aspect ratio doesn't match?

center img[full],
center video[full],
center iframe[full] {
    margin-top: -1rem;  /* counteract center top margin
    margin-left: -2rem;  /* counteract side margin
}
center img[full] {
    max-height: var(--slide-height);
    max-width: var(--slide-width);
}

*/

